//CppSudoku.cpp: This Program Emplements One of A Number of Possible Way of Creating A Fully Interactive "Sudoku" Game In C++.

#include <stdio.h>
#include <stdlib.h>
#include <conio.h>
#include <string.h>
#include <windows.h>

void gotoxy(int, int);// The Function Definition Requires: #include <windows.h>.

//Global Variables
FILE *in;
FILE *out;
//The "Sudoku" Table Related Variables
int Size;
int Sudoku9x9Display[9][9], Sudoku9x9File[9][9];
int Sudoku4x4Display[4][4], Sudoku4x4File[9][9];

	void gotoxy(int x, int y)
	{
	//Variables

	//Main Code
	HANDLE hConsoleOutput;
	COORD dwCursorPosition;

	dwCursorPosition.X = x;
	dwCursorPosition.Y = y;
	hConsoleOutput = GetStdHandle(STD_OUTPUT_HANDLE);
	SetConsoleCursorPosition(hConsoleOutput, dwCursorPosition);
	}

	int Write_Puzzle(int SudokuType)// The "Write_Puzzle" Function Saves The Sudoku.
	{
	//Variables
	int i,j,k,c;
	char FileName[15];

	//Main Code
	if (SudokuType == 9)
		{
		gotoxy(1,21);
		printf("Enter A File Name For Saving The Current Game: ");
		gotoxy(48,21);
		scanf("%s",FileName);
		out = fopen(FileName,"w");
		fclose(out);
		out = fopen(FileName,"a");
		for (i = 0; i<Size; i++)
			{
			for (j = 0; j<Size; j++)
				{
				if (Sudoku9x9File[i][j] == 0)
					{
					fprintf(out, "%d", Sudoku9x9File[i][j]);
					}
				else if (Sudoku9x9File[i][j] <= 0)
					{
					fprintf(out, "%d", abs(Sudoku9x9File[i][j]));
					}
				else
					{
					fprintf(out, "%c", Sudoku9x9File[i][j]);
					}
				if (j == 8)
					{
					fprintf(out, "\n");
					}
				if (ferror(out) != 0)
					{
					printf("Error (No. 1): Error In Writing To The File");
					return 0;
					}
				}
			}
		}
	if (SudokuType == 4)
		{
		gotoxy(1,21);
		printf("Enter A File Name For Saving The Current Game: ");
		gotoxy(48,21);
		scanf("%s",FileName);
		out = fopen(FileName,"w");
		fclose(out);
		out = fopen(FileName,"a");
		for (i = 0; i<Size; i++)
			{
			for (j = 0; j<Size; j++)
				{
				if (Sudoku4x4File[i][j] == 0)
					{
					fprintf(out, "%d", Sudoku4x4File[i][j]);
					}
				else if (Sudoku4x4File[i][j] <= 0)
					{
					fprintf(out, "%d", abs(Sudoku4x4File[i][j]));
					}
				else
					{
					fprintf(out, "%c", Sudoku4x4File[i][j]);
					}
				if (ferror(out) != 0)
					{
					printf("Error (No. 2): Error In Writing To The File");
					return 0;
					}
				if (j == 3)
					{
					fprintf(out, "\n");
					}
				}
			}
		}
	fclose(out);

	return 1;
	}

	int Table_Dimensions(int SudokuType, int i, int j)// We Set The X,Y Locations On The Screen.
	{
	//Variables

	//Main Code
	if (SudokuType == 9)
		{
		if (i <= 3 && j <= 3) //Square I
			{
			if (j == 1)
				{
				gotoxy(j + 2, i + 1);
				}
			if (j == 2)
				{
				gotoxy(j + 4, i + 1);
				}
			if (j == 3)
				{
				gotoxy(j + 7, i + 1);
				}
			}
		else if (i <= 3 && (j>3 && j <= 6)) // Square II
			{
			if (j == 4)
				{
				gotoxy(j + 9, i + 1);
				}
			if (j == 5)
				{
				gotoxy(j + 11, i + 1);
				}
			if (j == 6)
				{
				gotoxy(j + 13, i + 1);
				}
			}
		else if (i <= 3 && (j>6 && j <= 9)) // Square III
			{
			if (j == 7)
				{
				gotoxy(j + 16, i + 1);
				}
			if (j == 8)
				{
				gotoxy(j + 18, i + 1);
				}
			if (j == 9)
				{
				gotoxy(j + 20, i + 1);
				}
			}
		else if ((i>3 && i <= 6) && j <= 3) // Square IV
			{
			if (j == 1)
				{
				gotoxy(j + 2, i + 2);
				}
			if (j == 2)
				{
				gotoxy(j + 4, i + 2);
				}
			if (j == 3)
				{
				gotoxy(j + 7, i + 2);
				}
			}
		else if ((i>3 && i <= 6) && (j>3 && j <= 6)) //Square V
			{
			if (j == 4)
				{
				gotoxy(j + 9, i + 2);
				}
			if (j == 5)
				{
				gotoxy(j + 11, i + 2);
				}
			if (j == 6)
				{
				gotoxy(j + 13, i + 2);
				}
			}
		else if ((i>3 && i <= 6) && (j>6 && j <= 9)) // Square VI
			{
			if (j == 7)
				{
				gotoxy(j + 16, i + 2);
				}
			if (j == 8)
				{
				gotoxy(j + 18, i + 2);
				}
			if (j == 9)
				{
				gotoxy(j + 20, i + 2);
				}
			}
		else if ((i>6 && i <= 9) && j <= 3) // Square VII
			{
			if (j == 1)
				{
				gotoxy(j + 2, i + 3);
				}
			if (j == 2)
				{
				gotoxy(j + 4, i + 3);
				}
			if (j == 3)
				{
				gotoxy(j + 7, i + 3);
				}
			}
		else if ((i>6 && i <= 9) && (j >= 4 && j <= 6)) // Square VIII
			{
			if (j == 4)
				{
				gotoxy(j + 9, i + 3);
				}
			if (j == 5)
				{
				gotoxy(j + 11, i + 3);
				}
			if (j == 6)
				{
				gotoxy(j + 13, i + 3);
				}
			}
		else if ((i>6 && i <= 9) && (j>7 && j <= 9)) // Square IX*/
			{
			if (j == 7)
				{
				gotoxy(j + 16, i + 3);
				}
			if (j == 8)
				{
				gotoxy(j + 18, i + 3);
				}
			if (j == 9)
				{
				gotoxy(j + 20, i + 3);
				}
			}
		}

	if (SudokuType == 4)
		{
		if (i <= 2 && j <= 2) //Square I
			{
			if (j == 1)
				{
				gotoxy(j + 2, i + 1);
				}
			if (j == 2)
				{
				gotoxy(j + 4, i + 1);
				}
			}
		else if (i <= 2 && j >= 2) // Square II
			{
			if (j == 3)
				{
				gotoxy(j + 7, i + 1);
				}
			if (j == 4)
				{
				gotoxy(j + 9, i + 1);
				}
			}
		else if (i >= 2 && j <= 2) // Square III
			{
			if (j == 1)
				{
				gotoxy(j + 2, i + 2);
				}
			if (j == 2)
				{
				gotoxy(j + 4, i + 2);
				}
			}
		else if (i >= 2 && j >= 2) // Square IV
			{
			if (j == 3)
				{
				gotoxy(j + 7, i + 2);
				}
			if (j == 4)
				{
				gotoxy(j + 9, i + 2);
				}
			}
		}

	return 0;
	}

	int Write_Number(int SudokuType, int i, int j, int val)// This Function Stores All The Appropriate Values In The Tables.
	{
	//Variables

	//Main Code
	if (SudokuType == 9)
		{
		if (val != 0 && Sudoku9x9Display[i - 1][j - 1] == 0)
			{
			Table_Dimensions(SudokuType, i, j);
			printf("%d", val);
			Sudoku9x9Display[i - 1][j - 1] = val;
			Sudoku9x9File[i - 1][j - 1] = val + 'a' - 1;
			}
		if (val != 0 && Sudoku9x9Display[i - 1][j - 1]<0)
			{
			gotoxy(1, 20);
			printf("Error (No. 3): The Position Contains a Given Number                ");
			}
		if (val == 0 && Sudoku9x9Display[i - 1][j - 1] != 0 && Sudoku9x9Display[i - 1][j - 1] >= 0)
			{
			Table_Dimensions(SudokuType, i, j);
			printf("%d", val);
			Sudoku9x9Display[i - 1][j - 1] = 0;
			Sudoku9x9File[i - 1][j - 1] = 0;
			}
		}
	if (SudokuType == 4)
		{
		if (val != 0 && Sudoku4x4Display[i - 1][j - 1] == 0)
			{
			Table_Dimensions(SudokuType, i, j);
			printf("%d", val);
			Sudoku4x4Display[i - 1][j - 1] = val;
			Sudoku4x4File[i - 1][j - 1] = val + 'a' - 1;
			}
		if (val != 0 && Sudoku4x4Display[i - 1][j - 1]<0)
			{
			gotoxy(1, 20);
			printf("Error (No. 4): The Position Contains a Given Number                ");
			}
		if (val == 0 && Sudoku4x4Display[i - 1][j - 1] != 0 && Sudoku4x4Display[i - 1][j - 1] >= 0)
			{
			Table_Dimensions(SudokuType, i, j);
			printf("%d", val);
			Sudoku4x4Display[i - 1][j - 1] = 0;
			Sudoku4x4File[i - 1][j - 1] = 0;
			}
		}

	return 0;
	}

	int Sudoku_Complete(int SudokuType)// When A "Sudoku" Is Complete, Then The Game Is Over.
	{
	//Variables
	int i, j, Count9x9, Count4x4;

	//Main Code
	if (SudokuType == 9)
		{
		Count9x9 = 0;
		for (i = 0; i<9; i++)
			{
			for (j = 0; j<9; j++)
				{
				if (Sudoku9x9Display[i][j] == 0)
					{
					Count9x9++;
					}
				}
			}
		if (Count9x9 == 0)
			{
			gotoxy(1, 20);
			printf("Message (No. 1): Sudoku Complete. Enter (0,0=0) to Terminate The Game");
			return 1;
			}
		}
	if (SudokuType == 4)
		{
		Count4x4 = 0;
		for (i = 0; i<4; i++)
			{
			for (j = 0; j<4; j++)
				{
				if (Sudoku4x4Display[i][j] == 0)
					{
					Count4x4++;
					}
				}
			}
		if (Count4x4 == 0)
			{
			gotoxy(1, 20);
			printf("Message (No. 2): Sudoku Complete. Enter (0,0=0) to Terminate The Game");
			return 1;
			}
		}

	return 0;
	}

	int Rules_Control(int SudokuType, int i, int j, int val)// We Check For The "Sudoku" Rules.
	{
	//Variables
	int m, k, DisplayWriteStatus;

	//Main Code
	if (SudokuType == 9)
		{
		DisplayWriteStatus = 1;
		k = 0;
		while (k<9)
			{
			if (Sudoku9x9Display[i - 1][k] == -val && Sudoku9x9Display[i - 1][k] != 0)
				{
				gotoxy(1, 20);
				printf("Error (No. 5): The Number Already Exists in The Row            ");
				DisplayWriteStatus = 0;
				}
			k++;
			}
		k = 0;
		while (k<9)
			{
			if (Sudoku9x9Display[k][j - 1] == -val && Sudoku9x9Display[k][j - 1] != 0)
				{
				gotoxy(1, 20);
				printf("Error (No. 6): The Number Already Exists in The Column         ");
				DisplayWriteStatus = 0;
				}
			k++;
			}
		if (i <= 3 && j <= 3) //Square I
			{
			k = 0;
			m = 0;
			while (k <= 2)
				{
				while (m <= 2)
					{
					if (abs(Sudoku9x9Display[k][m]) == val && abs(Sudoku9x9Display[k][m]) != 0)
						{
						gotoxy(1, 20);
						printf("Error (No. 7): The New Number Already Exists in The Square                   ");
						DisplayWriteStatus = 0;
						}
					m++;
					}
				k++;
				m = 0;
				}
			}
		else if (i <= 3 && (j>3 && j <= 6)) // Square II
			{
			k = 0;
			m = 3;
			while (k <= 2)
				{
				while (m<6)
					{
					if (abs(Sudoku9x9Display[k][m]) == val && abs(Sudoku9x9Display[k][m]) != 0)
						{
						gotoxy(1, 20);
						printf("Error (No. 8): The New Number Already Exists in The Square                   ");
						DisplayWriteStatus = 0;
						}
					m++;
					}
				k++;
				m = 3;
				}
			}
		else if (i <= 3 && (j>6 && j <= 9)) // Square III
			{
			k = 0;
			m = 6;
			while (k <= 2)
				{
				while (m<9)
					{
					if (abs(Sudoku9x9Display[k][m]) == val && abs(Sudoku9x9Display[k][m]) != 0)
						{
						gotoxy(1, 20);
						printf("Error (No. 9): The New Number Already Exists in The Square                   ");
						DisplayWriteStatus = 0;
						}
					m++;
					}
				k++;
				m = 6;
				}
			}
		else if ((i>3 && i <= 6) && j <= 3) // Square IV
			{
			k = 3;
			m = 0;
			while (k <= 5)
				{
				while (m <= 2)
					{
					if (abs(Sudoku9x9Display[k][m]) == val && abs(Sudoku9x9Display[k][m]) != 0)
						{
						gotoxy(1, 20);
						printf("Error (No. 10): The New Number Already Exists in The Square                   ");
						DisplayWriteStatus = 0;
						}
					m++;
					}
				k++;
				m = 0;
				}
			}
		else if ((i>3 && i <= 6) && (j>3 && j <= 6)) //Square V
			{
			k = 3;
			m = 3;
			while (k <= 5)
				{
				while (m <= 5)
					{
					if (abs(Sudoku9x9Display[k][m]) == val && abs(Sudoku9x9Display[k][m]) != 0)
						{
						gotoxy(1, 20);
						printf("Error (No. 11): The New Number Already Exists in The Square                   ");
						DisplayWriteStatus = 0;
						}
					m++;
					}
				k++;
				m = 3;
				}
			}
		else if ((i>3 && i <= 6) && (j>6 && j <= 9)) // Square VI
			{
			k = 3;
			m = 6;
			while (k <= 5)
				{
				while (m<9)
					{
					if (abs(Sudoku9x9Display[k][m]) == val && abs(Sudoku9x9Display[k][m]) != 0)
						{
						gotoxy(1, 20);
						printf("Error (No. 12): The New Number Already Exists in The Square                   ");
						DisplayWriteStatus = 0;
						}
					m++;
					}
				k++;
				m = 6;
				}
			}
		else if ((i>6 && i <= 9) && j <= 3) // Square VII
			{
			k = 6;
			m = 0;
			while (k<9)
				{
				while (m <= 2)
					{
					if (abs(Sudoku9x9Display[k][m]) == val && abs(Sudoku9x9Display[k][m]) != 0)
						{
						gotoxy(1, 20);
						printf("Error (No. 13): The New Number Already Exists in The Square                   ");
						DisplayWriteStatus = 0;
						}
					m++;
					}
				k++;
				m = 0;
				}
			}
		else if ((i>6 && i <= 9) && (j >= 4 && j <= 6)) // Square VIII
			{
			k = 6;
			m = 3;
			while (k<9)
				{
				while (m<6)
					{
					if (abs(Sudoku9x9Display[k][m]) == val && abs(Sudoku9x9Display[k][m]) != 0)
						{
						gotoxy(1, 20);
						printf("Error (No. 14): The New Number Already Exists in The Square                   ");
						DisplayWriteStatus = 0;
						}
					m++;
					}
				k++;
				m = 3;
				}
			}
		else if ((i>6 && i <= 9) && (j>7 && j <= 9)) // Square IX
			{
			k = 6;
			m = 6;
			while (k<9)
				{
				while (m<9)
					{
					if (abs(Sudoku9x9Display[k][m]) == val && abs(Sudoku9x9Display[k][m]) != 0)
						{
						gotoxy(1, 20);
						printf("Error (No. 15): The New Number Already Exists in The Square                   ");
						DisplayWriteStatus = 0;
						}
					m++;
					}
				k++;
				m = 6;
				}
			}
		if (DisplayWriteStatus == 1)
			{
			Write_Number(SudokuType, i, j, val);
			}
		Sudoku_Complete(SudokuType);
		}

	if (SudokuType == 4)
		{
		DisplayWriteStatus = 1;
		k = 0;
		while (k<4)
			{
			if (Sudoku4x4Display[i - 1][k] == -val && Sudoku4x4Display[i - 1][k] != 0)
				{
				gotoxy(1, 20);
				printf("Error (No. 16): The Number Already Exists in The Row            ");
				DisplayWriteStatus = 0;
				}
			k++;
			}
		k = 0;
		while (k<4)
			{
			if (Sudoku4x4Display[k][j - 1] == -val && Sudoku4x4Display[k][j - 1] != 0)
				{
				gotoxy(1, 20);
				printf("Error (No. 17): The Number Already Exists in The Column         ");
				DisplayWriteStatus = 0;
				}
			k++;
			}
		if (i <= 2 && j <= 2) //Square I
			{
			k = 0;
			m = 0;
			while (k <= 1)
				{
				while (m <= 1)
					{
					if (abs(Sudoku4x4Display[k][m]) == val && abs(Sudoku4x4Display[k][m]) != 0)
						{
						gotoxy(1, 20);
						printf("Error (No. 18): The New Number Already Exists in The Square                   ");
						DisplayWriteStatus = 0;
						}
					m++;
					}
				k++;
				m = 0;
				}
			}
		else if (i <= 2 && j >= 2) // Square II
			{
			k = 0;
			m = 2;
			while (k <= 1)
				{
				while (m<4)
					{
					if (abs(Sudoku4x4Display[k][m]) == val && abs(Sudoku4x4Display[k][m]) != 0)
						{
						gotoxy(1, 20);
						printf("Error (No. 19): The New Number Already Exists in The Square                   ");
						DisplayWriteStatus = 0;
						}
					m++;
					}
				k++;
				m = 2;
				}
			}
		else if (i >= 2 && j <= 2) // Square III
			{
			k = 2;
			m = 0;
			while (k<4)
				{
				while (m <= 1)
					{
					if (abs(Sudoku4x4Display[k][m]) == val && abs(Sudoku4x4Display[k][m]) != 0)
						{
						gotoxy(1, 20);
						printf("Error (No. 20): The New Number Already Exists in The Square                   ");
						DisplayWriteStatus = 0;
						}
					m++;
					}
				k++;
				m = 0;
				}
			}
		else if (i >= 2 && j >= 2) // Square IV
			{
			k = 2;
			m = 2;
			while (k<4)
				{
				while (m<4)
					{
					if (abs(Sudoku4x4Display[k][m]) == val && abs(Sudoku4x4Display[k][m]) != 0)
						{
						gotoxy(1, 20);
						printf("Error (No. 21): The New Number Already Exists in The Square                   ");
						DisplayWriteStatus = 0;
						}
					m++;
					}
				k++;
				m = 2;
				}
			}
		if (DisplayWriteStatus == 1)
			{
			Write_Number(SudokuType, i, j, val);
			}
		Sudoku_Complete(SudokuType);
		}

	return 0;
	}

	int Play(int SudokuType)// This Function Starts The Game (The "Game Loop" Function).
	{
	//Variables
	int i, j, val;

	//Main Code
	gotoxy(1, 17);
	printf("Enter a New Number By Following The Format");
	gotoxy(1, 18);
	printf("<Row Number> , <Column Number> = New Number: ");
	gotoxy(46,18);
	printf("                      ");
	gotoxy(46, 18);
	if (scanf("%d,%d=%d", &i, &j, &val) != 3)
		{
		gotoxy(1, 20);
		printf("                                            ");
		while (getchar() != '\n');
			{
			gotoxy(1, 20);
			printf("Error (No. 22): Wrong Format of Command              ");
			}
		}
	gotoxy(1, 20);
	printf("                                                                ");
	if (i != 0 && j != 0)
		{
		if (SudokuType == 9)
			{
			if ((i >= 1 && i <= 9) && (j >= 1 && j <= 9) && (val >= 1 && val <= 9))
				{
				gotoxy(1, 20);
				Rules_Control(SudokuType, i, j, val);
				}
			if ((i >= 1 && i <= 9) && (j >= 1 && j <= 9) && val == 0)
				{
				Write_Number(SudokuType, i, j, val);
				}
			else
				{
				if (i<1 || i>9)
					{
					gotoxy(1, 20);
					printf("Error (No. 23): Wrong Row Number. Try Again         ");
					}
				if (j<1 || j>9)
					{
					gotoxy(1, 20);
					printf("Error (No. 24): Wrong Column Number. Try Again      ");
					}
				if (val<0 || val>9)
					{
					gotoxy(1, 20);
					printf("Error (No. 25): Wrong New Number. Try Again         ");
					}
				}
			}
		if (SudokuType == 4)
			{
			if ((i >= 1 && i <= 4) && (j >= 1 && j <= 4) && (val >= 0 && val <= 4))
				{
				gotoxy(1, 20);
				Rules_Control(SudokuType, i, j, val);
				}
			else if ((i >= 1 && i <= 4) && (j >= 1 && j <= 4) && val == 0)
				{
				Write_Number(SudokuType, i, j, val);
				}
			else
				{
				if (i<1 || i>4)
					{
					gotoxy(1, 20);
					printf("Error (No. 26): Wrong Row Number. Try Again          ");
					}
				if (j<1 || j>4)
					{
					gotoxy(1, 20);
					printf("Error (No. 27): Wrong Column Number. Try Again       ");
					}
				if (val<0 || val>4)
					{
					gotoxy(1, 20);
					printf("Error (No. 28): Wrong New Number. Try Again          ");
					}
				}
			}

		return 1;
		}
	else
		{
		Write_Puzzle(SudokuType);

		return 0;
		}
	}

	int Read_Puzzle(int SudokuType)// This Function Reads A "Sudoku" From A File.
	{
	//Variables
	int i,j,k,c;

	//Main Code
	if (SudokuType == 9)
		{
		for (i = 0; i<Size; i++)
			{
			for (j = 0; j<Size; j++)
				{
				c = fgetc(in);
				if (c == EOF)
					{
					return 0;
					}
				else if (c == '0')
					{
					Sudoku9x9Display[i][j] = 0;
					Sudoku9x9File[i][j] = 0;
					}
				else if (c <= '0' + Size && c >= '1')
					{
					Sudoku9x9Display[i][j] = '0' - c;
					Sudoku9x9File[i][j] = '0' - c;
					}
				else if (c <= 'a' + Size - 1 && c >= 'a')
					{
					Sudoku9x9Display[i][j] = c - 'a' + 1;
					Sudoku9x9File[i][j] = c - 'a' + 1;
					}
				else
					{
					return 0;
					}
				}
			fgetc(in);
			}
		for (i = 0; i<12; i++)
			{
			if (i<3)
				{
				if (Sudoku9x9Display[i][0]<0)
					{
					gotoxy(2, i + 2);
					printf("(%d)", abs(Sudoku9x9Display[i][0]));
					}
				else
					{
					gotoxy(3, i + 2);
					printf("%d", Sudoku9x9Display[i][0]);
					}
				if (Sudoku9x9Display[i][1]<0)
					{
					gotoxy(5, i + 2);
					printf("(%d)", abs(Sudoku9x9Display[i][1]));
					}
				else
					{
					gotoxy(6, i + 2);
					printf("%d", Sudoku9x9Display[i][1]);
					}
				if (Sudoku9x9Display[i][2]<0)
					{
					gotoxy(8, i + 2);
					printf("(%d)", abs(Sudoku9x9Display[i][2]));
					}
				else
					{
					gotoxy(9, i + 2);
					printf("%d", Sudoku9x9Display[i][2]);
					}
				if (Sudoku9x9Display[i][3]<0)
					{
					gotoxy(12, i + 2);
					printf("(%d)", abs(Sudoku9x9Display[i][3]));
					}
				else
					{
					gotoxy(13, i + 2);
					printf("%d", Sudoku9x9Display[i][3]);
					}
				if (Sudoku9x9Display[i][4]<0)
					{
					gotoxy(15, i + 2);
					printf("(%d)", abs(Sudoku9x9Display[i][4]));
					}
				else
					{
					gotoxy(16, i + 2);
					printf("%d", Sudoku9x9Display[i][4]);
					}
				if (Sudoku9x9Display[i][5]<0)
					{
					gotoxy(18, i + 2);
					printf("(%d)", abs(Sudoku9x9Display[i][5]));
					}
				else
					{
					gotoxy(19, i + 2);
					printf("%d", Sudoku9x9Display[i][5]);
					}
				if (Sudoku9x9Display[i][6]<0)
					{
					gotoxy(22, i + 2);
					printf("(%d)", abs(Sudoku9x9Display[i][6]));
					}
				else
					{
					gotoxy(23, i + 2);
					printf("%d", Sudoku9x9Display[i][6]);
					}
				if (Sudoku9x9Display[i][7]<0)
					{
					gotoxy(25, i + 2);
					printf("(%d)", abs(Sudoku9x9Display[i][7]));
					}
				else
					{
					gotoxy(26, i + 2);
					printf("%d", Sudoku9x9Display[i][7]);
					}
				if (Sudoku9x9Display[i][8]<0)
					{
					gotoxy(28, i + 2);
					printf("(%d)", abs(Sudoku9x9Display[i][8]));
					}
				else
					{
					gotoxy(29, i + 2);
					printf("%d", Sudoku9x9Display[i][8]);
					}
				}
			if (i>4 && i<8)
				{
				if (Sudoku9x9Display[i - 2][0]<0)
					{
					gotoxy(2, i + 1);
					printf("(%d)", abs(Sudoku9x9Display[i - 2][0]));
					}
				else
					{
					gotoxy(3, i + 1);
					printf("%d", Sudoku9x9Display[i - 2][0]);
					}
				if (Sudoku9x9Display[i - 2][1]<0)
					{
					gotoxy(5, i + 1);
					printf("(%d)", abs(Sudoku9x9Display[i - 2][1]));
					}
				else
					{
					gotoxy(6, i + 1);
					printf("%d", Sudoku9x9Display[i - 2][1]);
					}
				if (Sudoku9x9Display[i - 2][2]<0)
					{
					gotoxy(8, i + 1);
					printf("(%d)", abs(Sudoku9x9Display[i - 2][2]));
					}
				else
					{
					gotoxy(9, i + 1);
					printf("%d", Sudoku9x9Display[i - 2][2]);
					}
				if (Sudoku9x9Display[i - 2][3]<0)
					{
					gotoxy(12, i + 1);
					printf("(%d)", abs(Sudoku9x9Display[i - 2][3]));
					}
				else
					{
					gotoxy(13, i + 1);
					printf("%d", Sudoku9x9Display[i - 2][3]);
					}
				if (Sudoku9x9Display[i - 2][4]<0)
					{
					gotoxy(15, i + 1);
					printf("(%d)", abs(Sudoku9x9Display[i - 2][4]));
					}
				else
					{
					gotoxy(16, i + 1);
					printf("%d", Sudoku9x9Display[i - 2][4]);
					}
				if (Sudoku9x9Display[i - 2][5]<0)
					{
					gotoxy(18, i + 1);
					printf("(%d)", abs(Sudoku9x9Display[i - 2][5]));
					}
				else
					{
					gotoxy(19, i + 1);
					printf("%d", Sudoku9x9Display[i - 2][5]);
					}
				if (Sudoku9x9Display[i - 2][6]<0)
					{
					gotoxy(22, i + 1);
					printf("(%d)", abs(Sudoku9x9Display[i - 2][6]));
					}
				else
					{
					gotoxy(23, i + 1);
					printf("%d", Sudoku9x9Display[i - 2][6]);
					}
				if (Sudoku9x9Display[i - 2][7]<0)
					{
					gotoxy(25, i + 1);
					printf("(%d)", abs(Sudoku9x9Display[i - 2][7]));
					}
				else
					{
					gotoxy(26, i + 1);
					printf("%d", Sudoku9x9Display[i - 2][7]);
					}
				if (Sudoku9x9Display[i - 2][8]<0)
					{
					gotoxy(28, i + 1);
					printf("(%d)", abs(Sudoku9x9Display[i - 2][8]));
					}
				else
					{
					gotoxy(29, i + 1);
					printf("%d", Sudoku9x9Display[i - 2][8]);
					}
				}
			if (i>8 && i<12)
				{
				if (Sudoku9x9Display[i - 3][0]<0)
					{
					gotoxy(2, i + 1);
					printf("(%d)", abs(Sudoku9x9Display[i - 3][0]));
					}
				else
					{
					gotoxy(3, i + 1);
					printf("%d", Sudoku9x9Display[i - 3][0]);
					}
				if (Sudoku9x9Display[i - 3][1]<0)
					{
					gotoxy(5, i + 1);
					printf("(%d)", abs(Sudoku9x9Display[i - 3][1]));
					}
				else
					{
					gotoxy(6, i + 1);
					printf("%d", Sudoku9x9Display[i - 3][1]);
					}
				if (Sudoku9x9Display[i - 3][2]<0)
					{
					gotoxy(8, i + 1);
					printf("(%d)", abs(Sudoku9x9Display[i - 3][2]));
					}
				else
					{
					gotoxy(9, i + 1);
					printf("%d", Sudoku9x9Display[i - 3][2]);
					}
				if (Sudoku9x9Display[i - 3][3]<0)
					{
					gotoxy(12, i + 1);
					printf("(%d)", abs(Sudoku9x9Display[i - 3][3]));
					}
				else
					{
					gotoxy(13, i + 1);
					printf("%d", Sudoku9x9Display[i - 3][3]);
					}
				if (Sudoku9x9Display[i - 3][4]<0)
					{
					gotoxy(15, i + 1);
					printf("(%d)", abs(Sudoku9x9Display[i - 3][4]));
					}
				else
					{
					gotoxy(16, i + 1);
					printf("%d", Sudoku9x9Display[i - 3][4]);
					}
				if (Sudoku9x9Display[i - 3][5]<0)
					{
					gotoxy(18, i + 1);
					printf("(%d)", abs(Sudoku9x9Display[i - 3][5]));
					}
				else
					{
					gotoxy(19, i + 1);
					printf("%d", Sudoku9x9Display[i - 3][5]);
					}
				if (Sudoku9x9Display[i - 3][6]<0)
					{
					gotoxy(22, i + 1);
					printf("(%d)", abs(Sudoku9x9Display[i - 3][6]));
					}
				else
					{
					gotoxy(23, i + 1);
					printf("%d", Sudoku9x9Display[i - 3][6]);
					}
				if (Sudoku9x9Display[i - 3][7]<0)
					{
					gotoxy(25, i + 1);
					printf("(%d)", abs(Sudoku9x9Display[i - 3][7]));
					}
				else
					{
					gotoxy(26, i + 1);
					printf("%d", Sudoku9x9Display[i - 3][7]);
					}
				if (Sudoku9x9Display[i - 3][8]<0)
					{
					gotoxy(28, i + 1);
					printf("(%d)", abs(Sudoku9x9Display[i - 3][8]));
					}
				else
					{
					gotoxy(29, i + 1);
					printf("%d", Sudoku9x9Display[i - 3][8]);
					}
				}
			}
		}
	if (SudokuType == 4)
		{
		for (i = 0; i<Size; i++)
			{
			for (j = 0; j<Size; j++)
				{
				c = fgetc(in);
				if (c == EOF)
					{
					return 0;
					}
				else if (c == '0')
					{
					Sudoku4x4Display[i][j] = 0;
					Sudoku4x4File[i][j] = 0;
					}
				else if (c <= '0' + Size && c >= '1')
					{
					Sudoku4x4Display[i][j] = '0' - c;
					Sudoku4x4File[i][j] = '0' - c;
					}
				else if (c <= 'a' + Size - 1 && c >= 'a')
					{
					Sudoku4x4Display[i][j] = c - 'a' + 1;
					Sudoku4x4File[i][j] = c - 'a' + 1;
					}
				else
					{
					return 0;
					}
				}
			fgetc(in);
			}
		for (i = 0; i <= 4; i++)
			{
			if (i<2)
				{
				if (Sudoku4x4Display[i][0]<0)
					{
					gotoxy(2, i + 2);
					printf("(%d)", abs(Sudoku4x4Display[i][0]));
					}
				else
					{
					gotoxy(3, i + 2);
					printf("%d", Sudoku4x4Display[i][0]);
					}
				if (Sudoku4x4Display[i][1]<0)
					{
					gotoxy(5, i + 2);
					printf("(%d)", abs(Sudoku4x4Display[i][1]));
					}
				else
					{
					gotoxy(6, i + 2);
					printf("%d", Sudoku4x4Display[i][1]);
					}
				if (Sudoku4x4Display[i][2]<0)
					{
					gotoxy(9, i + 2);
					printf("(%d)", abs(Sudoku4x4Display[i][2]));
					}
				else
					{
					gotoxy(10, i + 2);
					printf("%d", Sudoku4x4Display[i][2]);
					}
				if (Sudoku4x4Display[i][3]<0)
					{
					gotoxy(12, i + 2);
					printf("(%d)", abs(Sudoku4x4Display[i][3]));
					}
				else
					{
					gotoxy(13, i + 2);
					printf("%d", Sudoku4x4Display[i][3]);
					}
				}
			if (i>2 && i<5)
				{
				if (Sudoku4x4Display[i - 1][0]<0)
					{
					gotoxy(2, i + 2);
					printf("(%d)", abs(Sudoku4x4Display[i - 1][0]));
					}
				else
					{
					gotoxy(3, i + 2);
					printf("%d", Sudoku4x4Display[i - 1][0]);
					}
				if (Sudoku4x4Display[i - 1][1]<0)
					{
					gotoxy(5, i + 2);
					printf("(%d)", abs(Sudoku4x4Display[i - 1][1]));
					}
				else
					{
					gotoxy(6, i + 2);
					printf("%d", Sudoku4x4Display[i - 1][1]);
					}
				if (Sudoku4x4Display[i - 1][2]<0)
					{
					gotoxy(9, i + 2);
					printf("(%d)", abs(Sudoku4x4Display[i - 1][2]));
					}
				else
					{
					gotoxy(10, i + 2);
					printf("%d", Sudoku4x4Display[i - 1][2]);
					}
				if (Sudoku4x4Display[i - 1][3]<0)
					{
					gotoxy(12, i + 2);
					printf("(%d)", abs(Sudoku4x4Display[i - 1][3]));
					}
				else
					{
					gotoxy(13, i + 2);
					printf("%d", Sudoku4x4Display[i - 1][3]);
					}
				}
			}
		}

	return 1;
	}

	void Display_Puzzle(int SudokuType, char FileName[])// We Display The "Sudoku" Frame.
	{
	//Variables
	int i,k;

	//Main Code
	system("cls");
	if (SudokuType + Size == 18)
		{
		gotoxy(1, 1);
		printf("*");
		gotoxy(1, 1);
		printf("*");
		gotoxy(31, 1);
		printf("*");
		gotoxy(1, 13);
		printf("*");
		gotoxy(31, 13);
		printf("*");
		for (i = 2; i<31; i++)
			{
			gotoxy(i, 1);
			printf("-");
			gotoxy(i, 13);
			printf("-");
			gotoxy(i, 5);
			printf("-");
			gotoxy(i, 9);
			printf("-");
			}
		for (i = 2; i<13; i++)
			{
			gotoxy(1, i);
			printf("|");
			gotoxy(31, i);
			printf("|");
			gotoxy(11, i);
			printf("|");
			gotoxy(21, i);
			printf("|");
			}
		if ((in = fopen(FileName, "r")) == NULL)
			{
			printf("Error (No. 29): The Sudoku File Not Found\n");
			exit(1);
			}
		Read_Puzzle(SudokuType);
		fclose(in);
		}
	if (SudokuType + Size == 8)
		{
		gotoxy(1, 1);
		printf("*");
		gotoxy(15, 1);
		printf("*");
		gotoxy(1, 7);
		printf("*");
		gotoxy(15, 7);
		printf("*");
		for (i = 2; i<15; i++)
			{
			gotoxy(i, 1);
			printf("-");
			gotoxy(i, 4);
			printf("-");
			gotoxy(i, 7);
			printf("-");
			}
		for (i = 2; i<7; i++)
			{
			gotoxy(1, i);
			printf("|");
			gotoxy(8, i);
			printf("|");
			gotoxy(15, i);
			printf("|");
			}
		if ((in = fopen(FileName, "r")) == NULL)
			{
			printf("Error (No. 30): The Sudoku File Not Found\n");
			exit(1);
			}
		Read_Puzzle(SudokuType);
		fclose(in);
		}
	}

	int main()
	{
	//Variables
	int SudokuType,i,k;
	char FileName[12];

	//Main Code
	system("cls");
	gotoxy(0,0);
	printf("aaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaa");
	gotoxy(0,1);
	printf("8                                                   8");
	gotoxy(0,2);
	printf("8  a-----------------a                              8");
	gotoxy(0,3);
	printf("8  | *** SUDOKU ***  |                              8");
	gotoxy(0,4);
	printf("8  | Dr. Anastasios  |                              8");
	gotoxy(0,5);
	printf("8  |  G. Bakaoukas   |                             8'");
	gotoxy(0,6);
	printf("8  | < 08/08/2006 >  |                             8a ");
	gotoxy(0,7);
	printf("8  ''---------------''                              8");
	gotoxy(0,8);
	printf("8                                                   8");
	gotoxy(0,9);
	printf("8                                                   8");
	gotoxy(0,10);
	printf("8                       ,aaaaa,                     8");
	gotoxy(0,11);
	printf("8                     ad':::::'ba                   8");
	gotoxy(0,12);
	printf("8                   ,d::;gPPRg;::b,                 8");
	gotoxy(0,13);
	printf("8                   d::dP'   `Yb::b                 8");
	gotoxy(0,14);
	printf("8                   8::8)     (8::8                 8");
	gotoxy(0,15);
	printf("8                   Y;:Yb     dP:;P  O              8");
	gotoxy(0,16);
	printf("8                   `Y;:'8ggg8':;P'                 8");
	gotoxy(0,17);
	printf("8                     'Yaa:::aaP'                   8");
	gotoxy(0,18);
	printf("8                        '''''                      8");
	gotoxy(0,19);
	printf("8                                                   8");
	gotoxy(0,20);
	printf("8                        ,d'b,                      8");
	gotoxy(0,21);
	printf("8                        d:::8                      8");
	gotoxy(0,22);
	printf("8                        8:::8                      8");
	gotoxy(0,23);
	printf("8                        8:::8                      8");
	gotoxy(0,24);
	printf("8                        8:::8                      8");
	gotoxy(0,25);
	printf("8                        8:::8                      8");
	gotoxy(0,26);
	printf("8                   aaa  `bad'  aaa                 8");
	gotoxy(0,27);
	printf("'''''''''''''''''''`   `'''''''`   `'''''''''''''''''");
	gotoxy(1,29);
	printf("Enter The Name of A Saved 'Sudoku' File (e.g. input1.txt): ");
	gotoxy(60,29);
	scanf("%s",&FileName);
	gotoxy(1,30);
	printf("Enter 'Sudoku' Dimensions (e.g. 9 (a 9x9 Sudoku) OR 4 (a 4x4 Sudoku): ");
	gotoxy(71,30);
	scanf("%d",&SudokuType);
	Size = SudokuType;

	Display_Puzzle(SudokuType,FileName);

	while (Play(SudokuType) != 0)
		{
		}

	return 0;
	}